unit uEFuses;

interface

procedure FusesEditor( pMem:Pointer; const processor:String );

implementation

uses TpString, TpCrt, TpMenu, uEditor, uDev;

var
  FuseArrOrig : array[0..7] of Word;
  FuseArr : array[0..7] of Word;
  bPIC84 : boolean;
  MenuHeight : Word;

Function DisplayFunc(S:string;K:MenuKey):string; far;
var
  i  : integer;
  color : byte;
begin

  if (Length(s)>=9) and ((s[9]='') or (s[9]='')) then
  begin
    FastWrite(' Fuses ',4,67,$1F);
    FastWrite(' ESC Exit  ENTER Change ',MenuHeight+4,50,$1F);

    FastWrite('2000:',MenuHeight+2,14,$17);
    for i:=0 to 7 do
    begin
      color := $1E;
      if FuseArrOrig[i]<>FuseArr[i] then color := $1C;
      FastWrite(HexW(FuseArr[i]),MenuHeight+2,20+5*i,color);
    end;

    FastWrite('2007: xx  .    .    .',MenuHeight+3,14,$17);

    for i:=0 to 13 do
    begin
      color := $1E;
      if 0<>(((FuseArr[7] xor FuseArrOrig[7]) shr i) and 1) then color := $1C;
      FastWrite( Chr($30+((FuseArr[7] shr i) and 1)),MenuHeight+3,38-i-(i div 4),color);
    end;
  end;

  DisplayFunc := s;
end;

procedure InitMenu(var M : Menu);
const
  ColorMenu : MenuColorArray = ($1F, $4C, $1F, $70, $1A, $70, $1F, $08);
  sDot : string = ' ....................................................';
var
  y : integer;
begin
  M := NewMenu([], @DisplayFunc);
  SubMenu(12,4,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
    MenuMode(false,true,false);

    y := 1;

    if bPIC84 then
    begin

      MenuItem('CP     '+sDot,y,1,$0A, ' Flash Program Memory Code Protection');
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Code protection off',             1, 19-2, $0A01, '' );
        MenuItem('Code is protected',               2,  3-2, $0A00, '' );
        PopSublevel;

    end else
    begin

      MenuItem('CP     '+sDot,y,1,$01, ' Flash Program Memory Code Protection');
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Code protection off',             1, 19-2, $0103, '' );
        MenuItem('Top 0x0100 words code protected', 2,  7-2, $0102, '' );
        MenuItem('Top half of code protected',      3,  7-2, $0101, '' );
        MenuItem('All code is protected',           4,  3-2, $0100, '' );
        PopSublevel;

      Inc(y);
      MenuItem('DEBUG  '+sDot,y,1,$02, ' In-Circuit Debugger Mode');
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Disabled, RB6 and RB7 are general purpose I/O pins',  1,  3-2, $0201, '' );
        MenuItem('Enabled, RB6 and RB7 are dedicated to the debugger',  2,  3-2, $0200, '' );
        PopSublevel;

      Inc(y);
      MenuItem('WRT    '+sDot,y,2,$03, ' Flash Program Memory Write Enable' );
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Memory may be written to by EECON control',     1,  3-2, $0301, '' );
        MenuItem('Memory may NOT be written to by EECON control', 2,  3-2, $0300, '' );
        PopSublevel;

      Inc(y);
      MenuItem('CPD    '+sDot,y,2,$04, ' Data EEPROM code protection' );
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Code protection off',               1,  3-2, $0401, '' );
        MenuItem('Data EEPROM memory code protected', 2,  3-2, $0400, '' );
        PopSublevel;

      Inc(y);
      MenuItem('LVP    '+sDot,y,1,$05, ' Low voltage programming Enable' );
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Enabled, RB3/PGM pin has PGM function', 1,  3-2, $0501, '' );
        MenuItem('Disabled, RB3/PGM is digital I/O',      2,  3-2, $0500, '' );
        PopSublevel;

      Inc(y);
      MenuItem('BODEN  '+sDot,y,1,$06, ' Brown-out Reset Enable' );
      SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
        MenuMode(false,true,false);
        MenuItem('Enabled ', 1,  3-2, $0601, '' );
        MenuItem('Disabled', 2,  3-2, $0600, '' );
        PopSublevel;
    end;

    Inc(y);
    MenuItem('PWRTE  '+sDot,y,4,$07, ' Power-up Timer Enable' );
    SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
      MenuMode(false,true,false);
      MenuItem('Enabled ', 1,  3-2, $0700, '' );
      MenuItem('Disabled', 2,  3-2, $0701, '' );
      PopSublevel;

    Inc(y);
    MenuItem('WDTE   '+sDot,y,1,$08, ' Watchdog Timer Enable' );
    SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
      MenuMode(false,true,false);
      MenuItem('Enabled ', 1,  3-2, $0801, '' );
      MenuItem('Disabled', 2,  3-2, $0800, '' );
      PopSublevel;

    Inc(y);
    MenuItem('FOSC   '+sDot,y,1,$09, ' Oscillator Selection' );
    SubMenu(19, y+5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
      MenuMode(false,true,false);
      MenuItem('RC oscillator', 1, 3-2, $0903, '' );
      MenuItem('HS oscillator', 2, 3-2, $0902, '' );
      MenuItem('XT oscillator', 3, 3-2, $0901, '' );
      MenuItem('LP oscillator', 4, 3-2, $0900, '' );
      PopSublevel;

    Inc(y);
    MenuItem('',  y+1, 0,  $F001, '' );
    MenuItem('',  y+2, 0,  $F002, '' );
    MenuItem('',  y, 0,  $F003, '' );
    PopSublevel;

  DisableMenuItem(M,$F001);
  DisableMenuItem(M,$F002);
  DisableMenuItem(M,$F003);
  ResetMenu(M);
  MenuHeight := y+3;
end;

type
  TFuse = object
    s   : byte;
    l   : byte;
    function mask : word;
    function update(w,newbits:word) : word;
    function bits(w:word) : word;
  end;

function TFuse.mask : word;
begin
  mask := ((1 shl l)-1) shl s;
end;

function TFuse.update(w,newbits:word) : word;
begin
  update := (w and not mask) or (newbits shl s);
end;

function TFuse.bits(w:word) : word;
begin
  bits := (w and mask) shr s;
end;

const
  fuse16F87x : array[1..10] of TFuse =
  (
    ( s: 4; l: 2 ), {  1 CP    }
    ( s:11; l: 1 ), {  2 DEBUG }
    ( s: 9; l: 1 ), {  3 WRT   }
    ( s: 8; l: 1 ), {  4 CPD   }
    ( s: 7; l: 1 ), {  5 LVP   }
    ( s: 6; l: 1 ), {  6 BODEN }
    ( s: 3; l: 1 ), {  7 PWRTE }
    ( s: 2; l: 1 ), {  8 WDTE  }
    ( s: 0; l: 2 ), {  9 FOSC  }
    ( s: 4; l: 1 )  { 10 CP84  }
  );

procedure UpdateMenu( var M:Menu );
var
  i : integer;
  ItemName, SubItemName : string;
begin
  for i:=Low(fuse16F87x) to High(fuse16F87x) do
  begin
    if GetMenuItemName(M, i, ItemName) then
    begin
      if GetMenuItemName(M, i*$100+fuse16F87x[i].bits(FuseArr[7]), SubItemName) then
      begin
        SetMenuItemName(M, i, Copy(ItemName,1,9)+SubItemName );
      end;
    end;
  end;

{  DrawSubMenu(M^.Root,nil);}
end;

procedure FusesEditor( pMem:Pointer; const processor:String );
var
  Ch : Char;
  Key : MenuKey;
  M : Menu;
begin

  bPIC84 := 0<>Pos('84',processor);

  Move( PWordArray(pMem)^, FuseArr, sizeof(FuseArr) );
  Move( PWordArray(pMem)^, FuseArrOrig, sizeof(FuseArr) );

  InitMenu( M );
  UpdateMenu( M );

  repeat
    Key := MenuChoice(M, Ch);
    if (Ch<>#13) and (Key<$100) then break;
    if Ch<>#13 then continue;
    if Key<$100 then continue;

    FuseArr[7] := fuse16F87x[Key div $100].update(FuseArr[7],Key mod $100);

    { extend CP }
    if bPIC84 then
    begin
      if 0<>(FuseArr[7] and $10) then
        FuseArr[7] := FuseArr[7] or $3FF0
      else
        FuseArr[7] := FuseArr[7] and not $3FF0;
    end else
    begin
      FuseArr[7] := (FuseArr[7] and not $3000) or ((FuseArr[7] and $30) shl 8);
    end;

    EraseSubMenu(M^.Active);
    PopSubMenu(M);

    UpdateMenu( M );
  until false;

  EraseMenu(M, False);
  DisposeMenu(M);

  PWordArray(pMem)^[7] := FuseArr[7];

end;

end.