unit uEWord;

interface

procedure WordHexEditor( pMem:Pointer; bc:Word );

implementation

uses TpString, TpCrt, TpWindow, uEditor, uDev, uDisasm;

type
  TWordEditor = object(TAbsEditor)
    procedure     CalcAddress; virtual;
    procedure     PaintLine( y:Word ); virtual;
    constructor   Init( pMem:Pointer; bc:Word  );
  end;

constructor TWordEditor.Init( pMem:Pointer; bc:Word  );
var
  i : integer;
begin
  inherited Init( pMem, bc, 2, $3FFF, 8 );
  Dec(m_DumpB,2);
{ FastWriteWindow('',WinHeight,0,$1F);}
  for i:=2 to WinWidth do FastWriteWindow('',WinHeight,i,$1F);
{ FastWriteWindow('',WinHeight,WinWidth+2,$1F);}
end;

procedure TWordEditor.CalcAddress;
var
  w : word;
  i : word;
  sCmnt : string;
begin
  inherited CalcAddress;
  w := PWordArray(m_pMem)^[m_Address];
  FastWriteWindow(HexW(m_Address),WinHeight+1,2,$17);
  FastWriteWindow(':',WinHeight+1,6,$17);
  FastWriteWindow(HexW(w),WinHeight+1,8,$1E);
  for i:=13 to WinWidth+1 do
    FastWriteWindow(' ',WinHeight+1,i,$17);
  FastWriteWindow(Disasm(w,'',sCmnt),WinHeight+1,13,$1F);
  if Length(sCmnt)<>0 then
    FastWriteWindow('; '+sCmnt,WinHeight+1,29,$17);
end;

procedure TWordEditor.PaintLine( y:Word );
var
  x : word;
  color : byte;
  offset : word;
begin
  if m_pEdit<>nil then
  begin
    FastWriteWindow( ' '+HexW((y-1+m_StartLine)*m_LineItems)+':', y, 1, $17 );
    for x:=0 to m_LineItems-1 do
    begin
      offset := (y-1+m_StartLine)*m_LineItems+x;
      if offset<m_bc then
      begin
        color := $1E;
        if PWordArray(m_pEdit)^[offset]<>PWordArray(m_pMem)^[offset] then color := $1C;
        FastWriteWindow( HexW(PWordArray(m_pEdit)^[offset]), y, m_DumpL+m_ItemWidth*x, color );
        FastWriteWindow( ChrDot(PWordArray(m_pEdit)^[offset]), y, m_TextL+x, color );
      end else
      begin
        FastWriteWindow( '    ', y, m_DumpL+m_ItemWidth*x, $10 );
        FastWriteWindow( ' ', y, m_TextL+x, $10 );
      end;
    end;
  end;
end;


procedure WordHexEditor( pMem:Pointer; bc:Word);
var
  e : TWordEditor;
  winTmp : WindowPtr;
begin
  MakeWindow( winTmp, 11, 2, 77, CurrentHeight-1,
                 true, true, true, $1E, $1F, $00, '');
  DisplayWindow(winTmp);

  WindowText( 0, '0000..'+HexW(bc-1) );
  WindowText( 1, 'Program memory' );
  WindowText( 3, 'DEL Undo  ESC Cancel  ENTER Save' );

  e.Init( pMem, bc );
  e.Execute;
  e.Free;

  DisposeWindow (EraseTopWindow);
end;

end.